function CalcWindowsXPLike() {
    this._constructor = CalcWindows95Like;
    this._constructor();
    this.additionalClassName = "BlueCalcContainer";
}


function CalcWindows95Like() {
    this.additionalClassName = null;

    this.cellWidth = 25;
    this.memoryToolTipBox = new ToolTipBox("CalcMemory");
    this.iframe = null;

    this.init = function () {
    };

    this.createDOM = function (calcObject) {


        var table = document.createElement("div");
        table.className = "CalcContainer " + (this.additionalClassName != null?this.additionalClassName:"");
        table.style.width = "152px";
        table.style.MozBoxSizing = "border-box";

        ICOpen.Utils.IE6_selectTag_workaround(table,1);

        var trs = [];
        for (var i = 0; i < 5; i++) {
            var tr = document.createElement("div");
            trs.push(tr);
            for (var j = 0; j < 6; j++) {
                var cell = document.createElement("span");
                cell.allign = "center";
                if (i == 0 && (j == 1 || j == 4)) {
                    cell.style.width = 2 * this.cellWidth + "px";
                    j++;
                }
                tr.appendChild(cell);
                cell.style.width = this.cellWidth + "px";
            }
            table.appendChild(tr);

        }


        var panel = this._prepareControlPanel(calcObject);

        trs[0].appendChild(panel);

        trs[0].childNodes[0].style.display = "none";
        trs[0].childNodes[1].className = "r0_c1";

        // buttons
        this.appendBtn(trs[0].childNodes[1], "&larr;", calcObject);
        this.appendBtn(trs[0].childNodes[2], "ce", calcObject);
        this.appendBtn(trs[0].childNodes[3], "c", calcObject);
        this.appendBtn(trs[2].childNodes[0], "mr", calcObject);
        this.appendBtn(trs[3].childNodes[0], "m+", calcObject);

        this.appendBtn(trs[1].childNodes[0], "mc", calcObject);
        this.appendBtn(trs[4].childNodes[0], "m-", calcObject);

        var fShow = function() {
            this.template.memoryToolTipBox.showRight(this, "&nbsp;" + this.calc.getMemoryFormatted(), false);
        };
        var fHide = function() {
            this.template.memoryToolTipBox.disappear(false);
        };
        var mButtons = [ trs[2].childNodes[0].childNodes[0],
                trs[1].childNodes[0].childNodes[0],
                trs[3].childNodes[0].childNodes[0],
                trs[4].childNodes[0].childNodes[0] ];

        for (var i = 0; i < mButtons.length; i++) {
            var mButton = mButtons[i];
            mButton.calc = calcObject;
            mButton.template = this;
            Event_addListener(mButton, "mouseover", fShow);
            var fnRefreshToolTip = function () {
                var calc = this.calc;
                ICOpen.Utils.setTimeout(function() {
                    new ToolTipBox('CalcMemory').getBox().innerHTML = "&nbsp;" + calc.getMemoryFormatted()
                }, 1);
            };
            Event_addListener(mButton, "click", fnRefreshToolTip);
            if (Event_isIE)
                Event_addListener(mButton, "dblclick", fnRefreshToolTip);

            Event_addListener(mButton, "mouseout", fHide);
        }

        this.appendBtn(trs[4].childNodes[1], "0", calcObject, "numberBtn");
        this.appendBtn(trs[4].childNodes[2], "+/-", calcObject, "numberBtn");
        this.appendBtn(trs[4].childNodes[3], calcObject.getDecimalSeparator(), calcObject, "numberBtn");

        this.appendBtn(trs[3].childNodes[1], "1", calcObject, "numberBtn");
        this.appendBtn(trs[3].childNodes[2], "2", calcObject, "numberBtn");
        this.appendBtn(trs[3].childNodes[3], "3", calcObject, "numberBtn");

        this.appendBtn(trs[2].childNodes[1], "4", calcObject, "numberBtn");
        this.appendBtn(trs[2].childNodes[2], "5", calcObject, "numberBtn");
        this.appendBtn(trs[2].childNodes[3], "6", calcObject, "numberBtn");

        this.appendBtn(trs[1].childNodes[1], "7", calcObject, "numberBtn");
        this.appendBtn(trs[1].childNodes[2], "8", calcObject, "numberBtn");
        this.appendBtn(trs[1].childNodes[3], "9", calcObject, "numberBtn");

        this.appendBtn(trs[1].childNodes[4], "/", calcObject);
        this.appendBtn(trs[2].childNodes[4], "*", calcObject);
        this.appendBtn(trs[3].childNodes[4], "-", calcObject);
        this.appendBtn(trs[4].childNodes[4], "+", calcObject);

        this.appendBtn(trs[1].childNodes[5], SQRT_SIGN, calcObject, "numberBtn");
        this.appendBtn(trs[2].childNodes[5], "%", calcObject, "numberBtn");
        this.appendBtn(trs[3].childNodes[5], "1/x", calcObject, "numberBtn");
        this.appendBtn(trs[4].childNodes[5], "=", calcObject);


        return table;
    };

    this._prepareControlPanel = function (calcObject) {
        var panel = document.createElement('div');
        panel.style.display = "inline";
        panel.style.position = "absolute";
        panel.style.textAlign = "right";

        panel.style.width = "75px";
        panel.style.marginLeft = "0px";

        var icons = [IC.MasterDecorator.imagesPath + "/helpIcon.gif",IC.MasterDecorator.imagesPath + "/positionIcon.gif",IC.MasterDecorator.imagesPath + "/closeIcon.gif"];
        for (var i = 0; i < 3; i++) {
            var icon = ImageButton.createButton();
            icon.border = 0;
            icon.src = icons[i];
            icons[i] = icon;

            panel.appendChild(icon);
        }
        Event_addListener(icons[0], "click", calcObject.helpIconClicked, calcObject, true);

        if (IC.MasterDecorator.getHelpIconClickedFunction() == null) {
            icons[0].style.display = "none";
        }

        Event_addListener(icons[1], "click", calcObject.positionIconClicked, calcObject, true);
        Event_addListener(icons[2], "click", calcObject.closeIconClicked, calcObject, true);

        return panel;
    };

    this.appendBtn = function(td, text, calcObject, className) {
        var res = document.createElement("button");
        td.appendChild(res);
        if (className)
            res.className = className;

        res.style.width = this.cellWidth + "px";
        res.innerHTML = text;

        Event_addListener(res, "click", CalcWindows95LikeButtonClickHandler, {listener:calcObject,text:text}, true);

        if (Event_isIE)
            Event_addListener(res, "dblclick", CalcWindows95LikeButtonClickHandler, {listener:calcObject,text:text}, true);

    };
    this.preload = function () {
        calcClassic_preload_images();
    }
}
;

var calcClassic_preload_images_called = false;

calcClassic_preload_images = function () {
    if (calcClassic_preload_images_called)
        return;
    calcClassic_preload_images_called = true;
    calcClassic_preload_images.images = [IC.MasterDecorator.imagesPath + "/buttonbg.gif",
            IC.MasterDecorator.imagesPath + "/helpIcon.gif",
            IC.MasterDecorator.imagesPath + "/closeIcon.gif",
            IC.MasterDecorator.imagesPath + "/positionIcon.gif"];

    for (var i = 0; i < calcClassic_preload_images.images.length; i++) {
        var img = new Image();
        img.src = calcClassic_preload_images.images[i];
        calcClassic_preload_images.images[i] = img;
    }

};


function CalcWindows95LikeButtonClickHandler(e) {
    Event_preventDefault(e);
    this.listener.buttonClicked(this.text);
}
;
