function CalcWindowsVistaLike() {
    // memory indicator stuff
    this.memoryToolTipBox = new ToolTipBox("CalcMemory");

    this.fShow = function() {
        this.template.memoryToolTipBox.showRight(this, "&nbsp;" + this.calc.getMemoryFormatted(), false);
    };

    this.fHide = function() {
        this.template.memoryToolTipBox.disappear(false);
    };

    this.fnRefreshToolTip = function () {
        var calc = this.calc;
        ICOpen.Utils.setTimeout(function() {
            new ToolTipBox('CalcMemory').getBox().innerHTML = "&nbsp;" + calc.getMemoryFormatted()
        }, 1);
    };
    // end of memory indicator stuff


    this.createDOM = function(calcObject) {
        var table = document.createElement("div");

        table.style.width = "142px";
        table.style.MozBoxSizing = "border-box";

        this.counter = CalcWindowsVistaLike.counter++;
        this.calcObject = ICOpen._(calcObject);
        table.innerHTML = longhorn_html
                .replace(/\$\{id\}/g,this.counter)
                .replace(/\$\{decimalSeparator\}/g,calcObject.getDecimalSeparator())
                .replace(/\$\{imgPath\}/g,IC.MasterDecorator.imagesPath);

        ICOpen.Utils.IE6_selectTag_workaround(table,0);

        return table;
    };

    this.attachListener = function (no, text, calcObject){
        var el = ICOpen.$('bt_'+no+"_"+text);
        Event_addListener(el, "click", CalcWindowsVistaLikeButtonClickHandler, {listener:calcObject,text:text}, true);
        if (Event_isIE)
            Event_addListener(el, "dblclick", CalcWindowsVistaLikeButtonClickHandler, {listener:calcObject,text:text}, true);

    };

    this.init = function (){
        var calcObject = ICOpen.$(this.calcObject);
        var labels = ["bs","c","ce","0","1","2","3","4","5","6","7","8","9","mr","mc","m+","m-",".","sqrt","*","%","/","-","+","1/x","+/-","="];
        for (var i=0;i<labels.length;i++)
            this.attachListener(this.counter,labels[i],calcObject);

        Event_addListener(ICOpen.$("bt_"+this.counter+"_help"), "click", calcObject.helpIconClicked, calcObject, true);

        if (IC.MasterDecorator.getHelpIconClickedFunction()==null){
            ICOpen.$("bt_"+this.counter+"_help").style.display="none";
        }

        Event_addListener(ICOpen.$("bt_"+this.counter+"_position"), "click", calcObject.positionIconClicked, calcObject, true);
        Event_addListener(ICOpen.$("bt_"+this.counter+"_close"), "click", calcObject.closeIconClicked, calcObject, true);

        var mButtons = [
                ICOpen.$("bt_"+this.counter+"_mc"),
                ICOpen.$("bt_"+this.counter+"_mr"),
                ICOpen.$("bt_"+this.counter+"_m+"),
                ICOpen.$("bt_"+this.counter+"_m-") ];

        for (var i = 0; i < mButtons.length; i++) {
            var mButton = mButtons[i];
            mButton.calc = calcObject;
            mButton.template = this;
            Event_addListener(mButton, "mouseover", this.fShow);
            Event_addListener(mButton, "click", this.fnRefreshToolTip);
            if (Event_isIE)
                Event_addListener(mButton, "dblclick", this.fnRefreshToolTip);

            Event_addListener(mButton, "mouseout", this.fHide);
        }


        longhorn_init();
    };

    this.preload = function (){
        window.longhorn_preload_images();
    };
}


function CalcWindowsVistaLikeButtonClickHandler(e) {
    Event_preventDefault(e);
    this.listener.buttonClicked(this.text);
};

CalcWindowsVistaLike.counter=0;

window.longhorn_preload_images_called = false;

window.longhorn_preload_images = function () {
    if (window.longhorn_preload_images_called)
        return;
    window.longhorn_preload_images_called =true;

    longhorn_preload_images.images =
        [IC.MasterDecorator.imagesPath + "/longhorn/bg.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/bg_bc.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/bg_bc_down.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/bg_bt.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/bg_bt_bl.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/bg_bt_br.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/bg_bt_down.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/bg_bx.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/bg_bx_down.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/bg_cmd_area.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/bottom.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/closeIcon.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/helpIcon.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/left.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/positionIcon.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/right.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/top1.gif",
                IC.MasterDecorator.imagesPath + "/longhorn/top2.gif",
                IC.MasterDecorator.imagesPath + "/helpIcon.gif",
                IC.MasterDecorator.imagesPath + "/closeIcon.gif",
                IC.MasterDecorator.imagesPath + "/positionIcon.gif"];
    
    for (var i = 0; i < longhorn_preload_images.images.length; i++) {
        var img = new Image();
        img.src = longhorn_preload_images.images[i];
        longhorn_preload_images.images[i] = img;
    }

};

window.longhorn_bt_bg_clean = function () {
    if (this.className != "longhorn_bt longhorn_bt_bg")
        this.className = "longhorn_bt longhorn_bt_bg";
};

window.longhorn_bt_bg_set = function() {
    this.className = "longhorn_bt longhorn_bt_bg_down";
};

window.longhorn_bx_bg_clean = function() {
    if (this.className != "longhorn_bt longhorn_bx_bg")
        this.className = "longhorn_bt longhorn_bx_bg";
};

window.longhorn_bx_bg_set = function() {
    this.className = "longhorn_bt longhorn_bx_bg_down";
};

window.longhorn_bc_bg_clean = function() {
    if (this.className != "longhorn_bc longhorn_bc_bg")
        this.className = "longhorn_bc longhorn_bc_bg";
};

window.longhorn_bc_bg_set = function() {
    this.className = "longhorn_bc longhorn_bc_bg_down";
};

window.longhorn_init = function () {

    var divs = document.getElementsByTagName("div");

    for (var i = 0; i < divs.length; i++) {
        if (divs[i].className == "longhorn_bt longhorn_bt_bg") {
            divs[i].onmousedown = window.longhorn_bt_bg_set;
            divs[i].onmouseup = window.longhorn_bt_bg_clean;
            divs[i].onmouseout = window.longhorn_bt_bg_clean;
        }
        if (divs[i].className == "longhorn_bt longhorn_bx_bg") {
            divs[i].onmousedown = window.longhorn_bx_bg_set;
            divs[i].onmouseup = window.longhorn_bx_bg_clean;
            divs[i].onmouseout = window.longhorn_bx_bg_clean;
        }
        if (divs[i].className == "longhorn_bc longhorn_bc_bg") {
            divs[i].onmousedown = window.longhorn_bc_bg_set;
            divs[i].onmouseup = window.longhorn_bc_bg_clean;
            divs[i].onmouseout = window.longhorn_bc_bg_clean;
        }
    }
};

var longhorn_html = '<table width="141px" cellpadding="0" cellspacing="0" border="0" onselectstart="return false">'+
'<tr>'+
'<td rowspan="5"><img width="5px" height="129px" src="${imgPath}/longhorn/left.gif"></td>'+
'<td><img width="132px" height="2px" src="${imgPath}/longhorn/top1.gif"></td>'+
'<td rowspan="5"><img width="5px" height="129px" src="${imgPath}/longhorn/right.gif"></td>'+
'</tr>'+
'<tr>'+
'<td><div class=longhorn_top_bg></div></td>'+
'</tr>'+
'<tr>'+
'<td><img src="${imgPath}/longhorn/top2.gif" width="132px" height="2px"></td>'+
'</tr>'+
'<tr>'+
'<td height="104px" bgcolor=black valign="top">'+
'<table cellpadding="0" cellspacing="1" style="margin:-1px -1px 0px 0px">'+
'<tr>'+
'<td><div id="bt_${id}_bs" class="longhorn_bt longhorn_bt_bg"><</div></td>'+
'<td><div id="bt_${id}_c" class="longhorn_bt longhorn_bt_bg">c</div></td>'+
'<td><div id="bt_${id}_ce" class="longhorn_bt longhorn_bt_bg">ce</div></td>'+
'<td colspan="3"><div class="longhorn_cmd">'+
'<table align="right" cellpadding="0" cellspacing="0" border="0">'+
'<tr>'+
'<td><div id="bt_${id}_help" class="longhorn_bc longhorn_bc_bg"><img height="11px" width="12px"'+
'src="${imgPath}/longhorn/helpIcon.gif"></div></td>'+
'<td><div id="bt_${id}_position" class="longhorn_bc longhorn_bc_bg"><img height="11px" width="12px"'+
'src="${imgPath}/longhorn/positionIcon.gif"></div></td>'+
'<td><div id="bt_${id}_close" class="longhorn_bc longhorn_bc_bg"><img height="11px" width="12px"'+
'src="${imgPath}/longhorn/closeIcon.gif"></div></td>'+
'</tr>'+
'</table>'+
'</div></td>'+
'</tr>'+
'<tr>'+
'<td><div id="bt_${id}_mc" class="longhorn_bt longhorn_bt_bg">mc</div></td>'+
'<td><div id="bt_${id}_7" class="longhorn_bt longhorn_bx_bg">7</div></td>'+
'<td><div id="bt_${id}_8" class="longhorn_bt longhorn_bx_bg">8</div></td>'+
'<td><div id="bt_${id}_9" class="longhorn_bt longhorn_bx_bg">9</div></td>'+
'<td><div id="bt_${id}_/" class="longhorn_bt longhorn_bt_bg">/</div></td>'+
'<td><div id="bt_${id}_sqrt" class="longhorn_bt longhorn_bt_bg">&#x221A;</div></td>'+
'</tr>'+
'<tr>'+
'<td><div id="bt_${id}_mr" class="longhorn_bt longhorn_bt_bg">mr</div></td>'+
'<td><div id="bt_${id}_4" class="longhorn_bt longhorn_bx_bg">4</div></td>'+
'<td><div id="bt_${id}_5" class="longhorn_bt longhorn_bx_bg">5</div></td>'+
'<td><div id="bt_${id}_6" class="longhorn_bt longhorn_bx_bg">6</div></td>'+
'<td><div id="bt_${id}_*" class="longhorn_bt longhorn_bt_bg">*</div></td>'+
'<td><div id="bt_${id}_%" class="longhorn_bt longhorn_bt_bg">%</div></td>'+
'</tr>'+
'<tr>'+
'<td><div id="bt_${id}_m-" class="longhorn_bt longhorn_bt_bg">m-</div></td>'+
'<td><div id="bt_${id}_1" class="longhorn_bt longhorn_bx_bg">1</div></td>'+
'<td><div id="bt_${id}_2" class="longhorn_bt longhorn_bx_bg">2</div></td>'+
'<td><div id="bt_${id}_3" class="longhorn_bt longhorn_bx_bg">3</div></td>'+
'<td><div id="bt_${id}_-" class="longhorn_bt longhorn_bt_bg">-</div></td>'+
'<td><div id="bt_${id}_1/x" class="longhorn_bt longhorn_bt_bg">1/x</div></td>'+
'</tr>'+
'<tr>'+
'<td><div id="bt_${id}_m+" class="longhorn_bt longhorn_bt_bg">m+</div></td>'+
'<td><div id="bt_${id}_0" class="longhorn_bt longhorn_bx_bg">0</div></td>'+
'<td><div id="bt_${id}_+/-" class="longhorn_bt longhorn_bt_bg">+/-</div></td>'+
'<td><div id="bt_${id}_." class="longhorn_bt longhorn_bx_bg">${decimalSeparator}</div></td>'+
'<td><div id="bt_${id}_+" class="longhorn_bt longhorn_bt_bg">+</div></td>'+
'<td><div id="bt_${id}_=" class="longhorn_bt longhorn_bt_bg">=</div></td>'+
'</tr>'+
'</table>'+
'</td>'+
'</tr>'+
'<tr>'+
'<td><img src="${imgPath}/longhorn/bottom.gif" width="132px" height="5px"></td>'+
'</tr>'+
'</table>';
