/**
Input Components logging class.
*/
ICOpen.Log = {
/** @ignore */
    _showOnInfo:false,
/** @ignore */
    _showOnWarn:false,
/** @ignore */
    _showOnError:true,
/** @ignore */
    messages:[],

/**
Specifies if debug window pops up on error message
*/
    setShowOnError:function(value){
        this._showOnError = value;
    },
/**
Specifies if debug window pops up on warn message
*/
    setShowOnWarn:function(value){
        this._showOnWarn = value;
    },
/**
Specifies if debug window pops up on info message
*/
    setShowOnInfo:function(value){
        this._showOnInfo = value;
    },
/**
Logs an message for the level of error
*/
    error:function(text) {
        this.messages.push({level:"error",date:new Date(),text:text});
        if (this._showOnError){
            this.show();
        }
    },
/**
Logs an message for the level of warn
*/
    warn:function(text) {
        this.messages.push({level:"warn",date:new Date(),text:text});
        if (this._showOnWarn)
            this.show();
    },
/**
Logs an message for the level of info
*/
    info:function(text) {
        this.messages.push({level:"info",date:new Date(),text:text});
        if (this._showOnInfo)
            this.show();
    },

/**
Purges the log
*/
    clear:function (){
        this.messages = [];
    },
/** @ignore */
    disablePopUpDisplayed : false,

/**
Displays debug window
*/
    show:function (){
        var dw = window.open("","IC_debug_window","resizable=yes,height=500,width=500,scrollbars=yes,status=no,toolbar=no,titlebar=no,menubar=no,location=no,top=0,left=0,x=0,y=0");
        if (dw==null && !this.disablePopUpDisplayed ){
            alert("Please disable pop-up window blocking.");
            this.disablePopUpDisplayed =true;
            return;
        }
        dw.document.open();
        dw.document.write("<html><style>body{border:0;}body,input,td{background-color:#EEF8FF;font-family:sans-serif;font-size:10px;}</style>");
        dw.document.write("<body>");
        dw.document.write(this._getBody());
        dw.document.write("</body></html>");
        dw.document.close();
     },

/** @ignore */
    _getBody: function (){
        var res = "<table border=1 width=100% cellspacing=0>"+
        "<tr>"+
        "<td>Time</td>"+
        "<td>Level</td>"+
        "<td>Message</td>"+
        "</tr>";
        for (var i=this.messages.length-1;i>=0;i--){
            var msg = this.messages[i];
//            ICOpen.$("logdiv").innerHTML += i+":"+this.msg+"<br>";
            res += "<tr>"+
            "<td>"+msg.date+"</td>"+
            "<td>"+msg.level+"</td>"+
            "<td>"+msg.text+"</td>"+
            "</tr>";
        }
        res += "</table>"+
        "<input type=button value='Refresh' onclick='document.body.innerHTML = window.opener.ICOpen.Log._getBody()'/>"+
        "<input type=button value='Close' onclick='window.close()'/>"+
        "<input type=button value='Close and Clear' onclick='window.opener.ICOpen.Log.clear();window.close()'/>";
        return res;
    }
};