function OICInputComponent(el) {

    this.element = ICOpen._(el);

    this.refiners = [];

    this.attach();
    this.justTyped = false;
}

OICInputComponent.prototype.onKeyPress = function (e) {

    if (e.keyCode == 13)
        return this.onEnterKey();

    var c = (typeof e.charCode == "undefined")? e.keyCode:c = e.charCode;
    if (e.keyCode > 0 && e.charCode == 0)
        return;

    this.onBeforeCharEntered(c, e);
};

OICInputComponent.prototype.onKeyDown = function (e) {

    for (var i = 0; i < this.refiners.length ; i++)
        if (this.refiners[i].handleKeyDown)
            this.refiners[i].handleKeyDown(null, e.keyCode, e);
};


OICInputComponent.prototype.getElement = function () {
    return ICOpen.$(this.element);
};

OICInputComponent.prototype.attach = function () {
    var el = this.getElement();
    Event_addListener(el, "keydown", this.onKeyDown, this, true);
    Event_addListener(el, "keypress", this.onKeyPress, this, true);
    Event_addListener(el, "blur", this.onBlur, this, true);

};


OICInputComponent.prototype.onBeforeCharEntered = function (c, e) {

    for (var i = 0; i < this.refiners.length; i++)
        this.refiners[i].handleCharEntered(null, c, e);

};

OICInputComponent.prototype.getValue = function () {
    return this.getElement().value;
};


OICInputComponent.prototype.focus = function () {
    this.getElement().focus();
};

OICInputComponent.prototype.getParsedValue = function () {
    return parseFloat(this.getElement().value);
};

OICInputComponent.prototype.acceptChar = function (ch) {
    this.getElement().value += ch;
    this.focus();
};

OICInputComponent.prototype.acceptBackSpace = function () {
    var el = this.getElement();
    if (el.value.length>0)
            el.value = el.value.substring(0,el.value.length-1);
    this.focus();
};

OICInputComponent.prototype.acceptNewValue = function (val) {
    if (typeof val != "string")
        val = "" + val;

    this.getElement().value = val;
    ICOpen.Utils.setSelectionRange(this.getElement(),val.length,val.length);
    this.focus();
};

OICInputComponent.prototype.onEnterKey = function (val) {
    return true;
};


