window.IC = {};
window.ICOpen = {Utils:{}};

ICOpen.Utils.attachToDocument = function(el){
    document.body.insertBefore(el,document.body.firstChild);
};
ICOpen.Utils.setTimeout = function (fn, delay){
//    ICOpen.Log.info("setTimeout delay:"+delay+" f:"+fn);
    return setTimeout(fn,delay);
};

ICOpen.Utils.markAsProcessed = function (el){
    el.wiseBlocksProcessed = true;
};

ICOpen.Utils.isProcessed = function (el){
    return el.wiseBlocksProcessed == true;
};

ICOpen.Utils.IE6_workaround_setSize = function (iframeId, tableId){
    ICOpen.Utils.setTimeout(function (){
        ICOpen.$(iframeId).style.height = ICOpen.$(tableId).offsetHeight + "px";
        ICOpen.$(iframeId).style.width = ICOpen.$(tableId).offsetWidth + "px";
    });
};

ICOpen.Utils.IE6_selectTag_workaround = function (table, borderWidth){

    if (document.all) { // IE6 <select> workaround
        var iframe = document.createElement("IFRAME");
        iframe.src = "javascript:void(null)";
        iframe.scrolling = "no";
        iframe.frameborder = "0";
        iframe.style.position = "absolute";
        iframe.style.display = "block";
        iframe.style.marginTop = (0-borderWidth)+"px";
        iframe.style.marginLeft = (0-borderWidth)+"px";
        iframe.style.filter = "alpha(opacity=0)";
        iframe.style.zIndex = "-32000";
        if (table.childNodes.length==0)
            table.appendChild(iframe);
        else
            table.insertBefore(iframe,table.firstChild);

        ICOpen.Utils.IE6_workaround_setSize(ICOpen._(iframe),ICOpen._(table));
    }
};

ICOpen.Utils.boxModel = null;
ICOpen.Utils.isBorderBoxModel = function (){
    if (ICOpen.Utils.boxModel ==null){
        var _outer = document.createElement("div");
        _outer.style.position = "absolute";
        _outer.style.visibility = "hidden";
        _outer.innerHTML = "<div style='width:25px;height:25px;border:1px solid black;overflow:hidden'>&nbsp;</div>";
        ICOpen.Utils.attachToDocument(_outer);
        ICOpen.Utils.boxModel = _outer.offsetWidth==25?"b":"c";
        _outer.parentNode.removeChild(_outer);
    }
    return ICOpen.Utils.boxModel=="b";
};


ICOpen.Utils.copyProperties = function (from, to) {
    for (var i in from){
        try{
            if (typeof from[i] !="undefined" && from[i] !=null ){
                to[i] = from[i];
           }
        } catch(e){
        }
    }
};

ICOpen.Utils.startsWithIgnoreCase = function (str1, str2) {
    if (typeof str1 == "undefined" || typeof str2 == "undefined" || str1 == null || str2 == null)
        return false;
    return str1.length >= str2.length && str1.toLowerCase().substring(0, str2.length) == str2.toLowerCase();
};


window.ICOpen_cleanupRefStore = {};
window.ICOpen_cleanupRefStore.lastId = 0;

ICOpen.$ = function (id) {
    var res = window.ICOpen_cleanupRefStore[id];
    if (! res)
        if (typeof id == 'string'){
            res = document.getElementById(id);
            if (res == null){
                var byName = document.getElementsByName(id);
                if (byName.length>0)
                    res = byName[0];
            }
        } else
            res = id;

    return res;
};

ICOpen._ = function (object) {
    if (object == null)
        return null;

    if (typeof object == "string")
        return object;

    var idFieldName = (typeof object.attributes == "object")?"id":"IC.id"; // use id for DOM objects and "IC[idFieldName]" for JavaScript

    if (typeof object[idFieldName] == "undefined" || object[idFieldName] == null || object[idFieldName] == "")
        object[idFieldName] = ICOpen_getUniqueId();

    if (ICOpen.$(object[idFieldName]) == null) {
        window.ICOpen_cleanupRefStore[object[idFieldName]] = object;
    }
    return object[idFieldName];
};

function ICOpen_getUniqueId() {
    return "$:" + (window.ICOpen_cleanupRefStore.lastId ++);
};

function ICOpen_cleanupRefStore() {
    for (var id in window.ICOpen_cleanupRefStore) {
        delete window.ICOpen_cleanupRefStore[id];
    }
    window["ICOpen_cleanupRefStore"] = null;
};

Event_addListener(window, "unload", ICOpen_cleanupRefStore);

ICOpen.Utils.setSelectionRange = function (el,start, end) {
    if (start > el.value.length) {
        start = el.value.length;
    }
    if (typeof end == "undefined" || end == null)
        end = start;

    if (el.setSelectionRange) {
        el.setSelectionRange(start, end);
    } else if (el.createTextRange) {
        var range = el.createTextRange();
        range.moveStart("character", start);
        range.moveEnd("character", end - el.value.length);
        range.select();
    }
};
